/****************************************************************************
* Copyright (C)2002 Lucent Technologies                                     *
* (clarkson@research.bell-labs.com http://cm.bell-labs.com/who/clarkson)    *
*                                                                           *
* This program is free software; you can redistribute it and/or             *
* modify it under the terms of the GNU General Public License               *
* as published by the Free Software Foundation; either                      *
* version 2 of the License, or (at your option) any later version.          *
*                                                                           *
* This program is distributed in the hope that it will be useful,           *
* but WITHOUT ANY WARRANTY; without even the implied warranty of            *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
* GNU General Public License for more details.                              *
*                                                                           *
* You should have received a copy of the GNU General Public License         *
* along with this program; if not, write to the Free Software               *
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA,                 *
* or visit http://www.gnu.org/licenses/gpl.html                             *
*****************************************************************************/


#include <stdio.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include <stdlib.h>
#include <assert.h>
#include <float.h>
#include <stdarg.h>

char **str_data;
int str_data_alloc;

char *my_strdup(char *a) {

	char *out = (char*)malloc((strlen(a)+1)*sizeof(char));
	memcpy(out, a, strlen(a)+1);
	return out;
}

int num_strings;

int get_data(FILE *IN) {

	char buf[1000];
	char *s;

	num_strings = 0;
	str_data_alloc = 3000;
	str_data = (char**)calloc(str_data_alloc, sizeof(char*));
	while (1) {
		if (!(s=fgets(buf,sizeof(buf),IN))) return num_strings;
		buf[strlen(s)-1] = '\0';
		if (num_strings>=str_data_alloc) {
			str_data_alloc *= 2;
			str_data = (char**)realloc(str_data,
						str_data_alloc*sizeof(char*));
		}
		str_data[num_strings++] = my_strdup(buf);
	}
	return num_strings;
}


int hamming_dist(char *s, char *t) {
	int d = 0;
	for ( ; *s && *t; s++, t++)
		if (*s != *t) d++;
	while (*s++) d++;
	while (*t++) d++;
	return d;
}


float this_dist(size_t i, size_t j) {

	char	*a = str_data[i],
		*b = str_data[j];
	return (float) hamming_dist(a,b);
}

float this_dist2(size_t i, size_t j) {return this_dist(i, j);}


void free_data(void) {

	int i;

	for (i=0; i< num_strings; i++) {
		free(str_data[i]);
	}

	free(str_data);

}

void this_show_point(size_t i) {printf("%s", str_data[i]); }

int this_color(int dum) {return 0;}
