/****************************************************************************
* Copyright (C)2002 Lucent Technologies                                     *
* (clarkson@research.bell-labs.com http://cm.bell-labs.com/who/clarkson)    *
*                                                                           *
* This program is free software; you can redistribute it and/or             *
* modify it under the terms of the GNU General Public License               *
* as published by the Free Software Foundation; either                      *
* version 2 of the License, or (at your option) any later version.          *
*                                                                           *
* This program is distributed in the hope that it will be useful,           *
* but WITHOUT ANY WARRANTY; without even the implied warranty of            *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
* GNU General Public License for more details.                              *
*                                                                           *
* You should have received a copy of the GNU General Public License         *
* along with this program; if not, write to the Free Software               *
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA,                 *
* or visit http://www.gnu.org/licenses/gpl.html                             *
*****************************************************************************/


#ifdef __cplusplus
extern "C" {
#endif


extern
float
	stat_change_nn,
	stat_max_heap_entries,
	stat_search_loop;

extern float dcounts[10];


#undef stat_inc_change_nn 
#undef stat_inc_search_loop
#undef stat_update_max_heap_entries

#define stat_inc_change_nn {stat_change_nn++;}
#define stat_inc_search_loop {stat_search_loop++;}
#define stat_update_max_heap_entries(X) {if ((float)X>stat_max_heap_entries) stat_max_heap_entries = (float)X;}


void my_show_point(size_t);

size_t closest(sb_distance, size_t, size_t, float, char);

void make_shuffle(size_t, size_t, size_t);
extern size_t *shufmat;

void test_sbt(sbp, size_t, size_t, size_t, float, search_sb_f, search_M_f);

float my_dist(size_t, size_t);

float my_dist2(size_t, size_t);


typedef enum {test_closest, test_fixed_radius, test_k_nn} sbtesttypes;
extern sbtesttypes sbtesttype;

extern char longprint;
void print_prep(sbp sbt);


#define NELEMS(x) (sizeof( x ) / sizeof( x [0]))

#define ITERATE(x) for (i_##x = 0; i_##x < NELEMS( x ); i_##x## ++)

#ifdef __cplusplus
}
#endif
