/****************************************************************************
* Copyright (C)2002 Lucent Technologies                                     *
* (clarkson@research.bell-labs.com http://cm.bell-labs.com/who/clarkson)    *
*                                                                           *
* This program is free software; you can redistribute it and/or             *
* modify it under the terms of the GNU General Public License               *
* as published by the Free Software Foundation; either                      *
* version 2 of the License, or (at your option) any later version.          *
*                                                                           *
* This program is distributed in the hope that it will be useful,           *
* but WITHOUT ANY WARRANTY; without even the implied warranty of            *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
* GNU General Public License for more details.                              *
*                                                                           *
* You should have received a copy of the GNU General Public License         *
* along with this program; if not, write to the Free Software               *
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA,                 *
* or visit http://www.gnu.org/licenses/gpl.html                             *
*****************************************************************************/


typedef struct SD *SDp;

typedef struct heap {
    SDp h;
    size_t num_entries, num_allocated;
} heap;

void print_heap_recur(heap *h, size_t j, size_t level);
void print_heap(heap *h);
void sift_down(heap *h, size_t k);
void sift_up(heap *h, size_t k);
void insert_heap(heap *h, size_t a, float d);
void delete_heap(heap *h, size_t j);
void init_heap(heap *h);
void free_heap(heap* h);

#define top(H) H.h[0]
#define topp(pH) pH->h[0]

