/****************************************************************************
* Copyright (C)2002 Lucent Technologies                                     *
* (clarkson@research.bell-labs.com http://cm.bell-labs.com/who/clarkson)    *
*                                                                           *
* This program is free software; you can redistribute it and/or             *
* modify it under the terms of the GNU General Public License               *
* as published by the Free Software Foundation; either                      *
* version 2 of the License, or (at your option) any later version.          *
*                                                                           *
* This program is distributed in the hope that it will be useful,           *
* but WITHOUT ANY WARRANTY; without even the implied warranty of            *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
* GNU General Public License for more details.                              *
*                                                                           *
* You should have received a copy of the GNU General Public License         *
* along with this program; if not, write to the Free Software               *
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA,                 *
* or visit http://www.gnu.org/licenses/gpl.html                             *
*****************************************************************************/


#include <stdio.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include <stdlib.h>
#include <assert.h>
#include <float.h>
#include <stdarg.h>




int *str_data;
int str_data_alloc;

char *str_tab;
int str_tab_alloc, str_tab_used;

char *my_strdup(char *a) {

	char *out = (char*)malloc((strlen(a)+1)*sizeof(char));
	memcpy(out, a, strlen(a)+1);
	return out;
}

int num_strings;

int get_data(FILE *IN) {

	char buf[1000];
	char *s;

	num_strings = 0;
	str_data_alloc = 3000;
	str_data = (int*)calloc(str_data_alloc, sizeof(int));
	str_tab_used = 0;
	str_tab_alloc = 10000;
	str_tab = (char*)calloc(str_tab_alloc, sizeof(char));
	while (1) {
		if (!(s=fgets(buf,sizeof(buf),IN))) 
			return num_strings;
		buf[strlen(s)-1] = '\0';
		if (num_strings>=str_data_alloc) {
			str_data_alloc *= 2;
			str_data = (int*)realloc(str_data,
						str_data_alloc*sizeof(int));
		}
		if ((int)strlen(buf)+str_tab_used+1 >= str_tab_alloc) {
			str_tab_alloc *= 2;
			str_tab = (char*)realloc(str_tab, str_tab_alloc*sizeof(char));
		}
		strcpy(str_tab+str_tab_used, buf);
		str_data[num_strings++] = str_tab_used;
		str_tab_used += strlen(buf)+1;
	}
	return num_strings;
}


int edit_dist(char *a, char *b) {

	int dists[100][100];
	int cdel = 1, cins = 1, csub = 2;
	int i, j;
	int lena = strlen(a), lenb = strlen(b);
	int v, min;

	dists[0][0] = 0;
	for (i=1; i<=lena; i++)
		dists[i][0] = dists[i-1][0] + cdel;
	for (j=1; j<=lenb; j++)
		dists[0][j] = dists[0][j-1] + cins;
	
	for (i=1; i<=lena; i++) for (j=1; j<=lenb; j++) {
		min = dists[i-1][j] + cdel;
		v = dists[i][j-1] + cins;
		if (v < min) min = v;
		v = dists[i-1][j-1] + ((a[i-1]==b[j-1]) ? 0 : csub);
		if (v < min) min = v;
		dists[i][j] = min;
	}
/*
for (i=0; i<=lena; i++) {
	for (j=0; j<=lenb; j++) printf("%d	", dists[i][j]);
	printf("\n");
}
*/
	return dists[lena][lenb];
}


float this_dist(size_t i, size_t j) {

	char
		*a = str_tab+str_data[i],
		*b = str_tab+str_data[j];

	return (float) edit_dist(a,b);
}

float this_dist2(size_t i, size_t j) {return this_dist(i, j);}


void free_data(void) {
	free(str_data);
	free(str_tab);

}

void this_show_point(size_t i) {printf("%s", str_data[i]); }

int this_color(int dum) {return 0;}
